
var iTouchX;
var iTouchY;
var wgt = page.getWidget('imgColorWheel');

function lblY_onDataUpdate(me, eventInfo)
{   
    iTouchY = eventInfo.newValue;
    rgb();
}

function lblX_onDataUpdate(me, eventInfo)
{
    iTouchX = eventInfo.newValue;
    rgb();
}

function rgb() {
    var Xpos = ((iTouchX - wgt.x) / wgt.width) * 2.0 - 1.0;
    var Ypos = ((iTouchY - wgt.y) / wgt.height) * 2.0 - 1.0;
    var Radius = Math.sqrt((Xpos * Xpos) + (Ypos * Ypos));
    var R, G, B;			// Base colors
    
    if (Radius <= 1.00)	// Press within wheel ?
    {
        // Calculate angle in degrees
        var Angle = Math.atan(Ypos / Xpos) * 180.0 / Math.PI + 90.0;
        if (Xpos < 0.0)
            Angle += 180.0;
        
        var AngleRemains = Angle % 60.0;
        var AngleSection = (Angle - AngleRemains) / 60;
        
        // Calculate base color dependent of angle
        switch (AngleSection)
        {
        case 0:	// 0 - 60 degrees
            R = 255;
            G = Math.round(AngleRemains * 4.25);
            B = 0;
            break;
            
        case 1:	// 60 - 120 degrees
            R = Math.round(255 - (AngleRemains * 4.25));			
            G = 255;
            B = 0;
            break;
            
        case 2:	// 120 - 180 degrees
            R = 0;			
            G = 255;
            B = Math.round(AngleRemains * 4.25);
            break;
            
        case 3:	// 180 - 240 degrees
            R = 0;			
            G = Math.round(255 - (AngleRemains * 4.25));
            B = 255;
            break;
            
        case 4:	// 240 - 300 degrees
            R = Math.round(AngleRemains * 4.25);			
            G = 0;
            B = 255;
            break;
            
        case 5:	// 300 - 360 degrees
            R = 255;			
            G = 0;
            B = Math.round(255 - (AngleRemains * 4.25));
            break;
        }
        
        // Brightness adjustment
        var BR = Math.round((255 - R) * Radius);
        var BG = Math.round((255 - G) * Radius);
        var BB = Math.round((255 - B) * Radius);
        
        R = 255 - BR;			
        G = 255 - BG;			
        B = 255 - BB;			
        
        var RGB16 = ((R & 0xF8) << 8) + ((G & 0xFC) << 3) + (B >> 3);
        project.setTag('colorRGB', RGB16String(RGB16));
        project.setTag ('R', R);
        project.setTag ('G', G);
        project.setTag ('B', B);
    }
}
    
// Convert RGB16 value to string for color
function RGB16String(RGB16)
{
    var Color =  "rgb(" + ((RGB16 & 0xF800) >> 8) + "," + ((RGB16 & 0x07E0) >> 3) + "," + ((RGB16 & 0x001F) << 3) + ")";
    return Color;
}
